#include <stdio.h>
#include <stdlib.h>

#include "util.h"
#include "util.c"

int  x=0;
int  max=0;

#define MAX_ENTRIES  3

typedef struct {
  char name[128];    /* Werte des NCSA-Teams, GEFAEHRLICH! */
  char val[128];
} entry_get;

typedef struct {
  char *name;
  char *val;
} entry_post;

entry_post entries_post[MAX_ENTRIES];
entry_get  entries_get[MAX_ENTRIES];

int main(void) {
  /* POST oder GET */
  if (strcmp(getenv("REQUEST_METHOD"), "POST")) {
    char       *cl;

    if (cl = getenv("QUERY_STRING"), cl == NULL) {
      printf("Nix uebergeben!\n");
      exit(1);
    }

    for (x=0; cl[0] != '\0'; x++) {
      max=x;
      getword(entries_get[x].val,cl,'&');
      plustospace(entries_get[x].val);
      unescape_url(entries_get[x].val);
      getword(entries_get[x].name, entries_get[x].val, '=');
    }
  } else { /* POST-Methode */
    int        cl;

    cl = atoi(getenv("CONTENT_LENGTH"));

    for(x=0; cl && (!feof(stdin)); x++) {
      max=x;
      entries_post[x].val = fmakeword(stdin, '&', &cl);
      plustospace(entries_post[x].val);
      unescape_url(entries_post[x].val);
      entries_post[x].name = makeword(entries_post[x].val, '=');
    }
  }

  printf("Content-Type: text/html\n\n");
  printf("<HTML>\n");
  printf("  <HEAD>\n");
  printf("    <TITLE>CGI-Programme in C</TITLE>\n");
  printf("  </HEAD>\n\n");
  printf("  <BODY>\n");
  printf("    <H1>CGI-Programme in C / Ergebnis der C-Auswertung</H1>\n");
  printf("    <H2>&copy; Heise Verlag, Hannover</H2>\n\n");
  printf("    <H3>C hat die folgenden Name/Wert-Paare identifiziert:</H3>\n");
  printf("    <OL>\n");

  if (strcmp(getenv("REQUEST_METHOD"), "POST"))
    for (x=0; x<=max; x++)
      printf("      <LI> <CODE>%s = %s</CODE>\n",
	     entries_get[x].name,entries_get[x].val);
  else
    for (x=0; x<=max; x++)
      printf("      <LI> <CODE>%s= %s</CODE>\n",
	     entries_post[x].name,entries_post[x].val);

  printf("    </OL>\n");
  printf("    Zugriffsmethode: %s\n", getenv("REQUEST_METHOD"));
  printf("  </BODY>\n");
  printf("</HTML>\n");

  exit(0);
}
